
*------------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*------------------------------------------*

#include "hmg.ch"

FUNCTION Main

*--------------------------------------------------------------------------------------------------------------------*
 Private fColor := { || if ( recno()/2 == int(recno()/2) ,  {000,168,000} , { 015,000,255 } ) }
 Private bcolor := { || if ( This.CellRowIndex/2 = int (This.CellRowIndex/2) , { 206,253,240} , {255,255,211} ) } 
*--------------------------------------------------------------------------------------------------------------------*

   REQUEST DBFCDX
   RDDSETDEFAULT( "DBFCDX" )
   
 *----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET DECIMALS TO 2
  SET TOOLTIPSTYLE BALLOON
*----------------------------------*

  DEFINE WINDOW Form_1     ;
      AT 90,90             ;
      WIDTH 580            ;
      HEIGHT 330           ;
      TITLE "Browse DBF - " + STR( YEAR( DATE()) ) ; 
      MAIN NOSIZE NOMAXIMIZE     
  
      ON KEY ESCAPE ACTION Form_1.Release           
    
      SELECT 1 
      USE PRODUTO
      DbGoTop()   

      DEFINE BROWSE Browse_1
        ROW    020
        COL    020
        WIDTH  540  
        HEIGHT 185 
        VALUE NIL
        WIDTHS  grid_data_widths()
        HEADERS grid_data_headers()
        WORKAREA PRODUTO
        FIELDS  grid_data_columnfields() 
        FONTNAME "Arial"
        FONTSIZE 9              
        FONTBOLD .T.
        FONTITALIC .F.
        LOCK .T.                          
        VSCROLLBAR .T.
        ALLOWEDIT .F.
        ONCHANGE PositionData()
        DYNAMICFORECOLOR { fcolor, fcolor, fcolor, fcolor, fcolor, fcolor}  
        DYNAMICBACKCOLOR { bColor, bColor, bColor, bColor, bColor, bColor}   
        JUSTIFY { BROWSE_JTFY_RIGHT,BROWSE_JTFY_LEFT,BROWSE_JTFY_RIGHT,BROWSE_JTFY_CENTER,BROWSE_JTFY_CENTER,BROWSE_JTFY_CENTER }
     END BROWSE 

     DEFINE BUTTON But_Exit
         ROW    240
         COL    430 
         WIDTH  105
         HEIGHT 030
         CAPTION "&Exit" 
         PICTURE "Resource\Cancel.bmp"
         PICTALIGNMENT LEFT           
         ACTION Form_1.Release
      END BUTTON   
*----------------------------------------------------------------------------------------*

              @ 244, 040 Label Label_1G    ;
                     width   120           ;
                     height  035           ;
                     FONT "Arial" SIZE 9 BOLD ITALIC;
                     Value "Records:"
                   
              @ 244, 110 Label Label_2G    ;
                     width   050           ;
                     height  035           ;
                     FONT "Arial" SIZE 9 BOLD ITALIC;
                     Value ""

*-----------------------------------------------------------------------------------*
*-----------------------------------------  Up-Down  -------------------------------*
*-----------------------------------------------------------------------------------* 
*-----------------------------------------------------------------------------------* 

    DEFINE BUTTON But_01  
         ROW    240    
         COL    195          
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen01.jpg"            
         TOOLTIP 'First'//'Primero'    
         ACTION ( DbGoTop() , Form_1.Browse_1.value := Produto->(RecNo()) )                         
     END BUTTON

    DEFINE BUTTON But_02 
         ROW    240  
         COL    225  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen02.jpg"     
         TOOLTIP 'Previous'//'Anterior'   
         ACTION ( DbSkip(-1) , Form_1.Browse_1.value := Produto->(RecNo()) )      
    END BUTTON
 
    DEFINE BUTTON But_03
         ROW    240 
         COL    255  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen03.jpg"
         TOOLTIP 'Next'//'Siguiente'    
         ACTION   ( DbSkip(1) ,if ( eof() , DbGoBottom() , Nil ) , Form_1.Browse_1.value := Produto->(RecNo()) )      
    END BUTTON   

    DEFINE BUTTON But_04
         ROW    240 
         COL    285  
         WIDTH  030
         HEIGHT 030 
         PICTURE "Resource/Imagen04.jpg"   
         TOOLTIP 'Last'  //'Ultimo' 
         ACTION ( DbGoBottom() , Form_1.Browse_1.value := Produto->(RecNo()) )      
    END BUTTON  
   
   Chane_Style() 

  END WINDOW

   SETWINDOWCURSOR (Form_1.But_Exit.Handle, "resource\finger.cur")

   Form_1.Browse_1.value := 1
   Form_1.Browse_1.Refresh
 
   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

Return nil

*-----------------------------------------------------------------------------------------*
*-----------------------------------------------------------------------------------------*

*------------------------------------------------------------* 
FUNCTION Chane_Style()   // Hace Recuadro en Browse_1
*------------------------------------------------------------* 
 HMG_ChangeWindowStyle ( GetControlHandle("Browse_1","Form_1"), LVS_REPORT, NIL, .T. )

Return

*------------------------------------------------------------* 
 Function PositionData()  // N de Registro / Total  
*------------------------------------------------------------*

   PRIVATE  nValor , nCouR 

   nValor := PRODUTO->(recno())           
   Select('PRODUTO')
   nCouR  := LASTREC() 

   Form_1.Label_2G.value := ALLTRIM( STR(nValor) ) + SPACE(1) + "/" + SPACE(1) + ALLTRIM( STR(nCouR) )    

Return 

*----------------------------------------*
FUNCTION grid_data_DynamicBackColor()
*----------------------------------------*

LOCAL aDynamicBackColor := {}

   aDynamicBackColor := { bBackColor,;
                          bBackColor,;
                          bBackColor,;
                          bBackColor,;
                          bBackColor,;
                          bBackColor }

RETURN aDynamicBackColor

*----------------------------------------*
FUNCTION grid_data_widths()
*----------------------------------------*
LOCAL awidths := {}

   awidths := { 70,342,100,100,60,82 }    

RETURN awidths

*----------------------------------------*
FUNCTION grid_data_headers()
*----------------------------------------*
LOCAL aheaders

   aheaders := { "Codigo",;
                 "Nome",;
                 "Preco",;
                 "Entrada",;
                 "Ativo",;
                 "Observao" }

RETURN aheaders

*----------------------------------------*
FUNCTION grid_data_columncontrols()
*----------------------------------------*
LOCAL aColumnControls

   aColumnControls := { { "TEXTBOX","NUMERIC","99999" },;
                        { "TEXTBOX","CHARACTER" },;
                        { "TEXTBOX","NUMERIC","9999999999.99" },;
                        { "DATEPICKER","UPDOWN" },;
                        { "CHECKBOX",".T.",".F." },;
                        { "EDITBOX" } }

RETURN aColumnControls 

*----------------------------------------*
FUNCTION grid_data_columnfields()
*----------------------------------------*
LOCAL aColumnFields

   aColumnFields := { "produto->codpro",;
                      "produto->nompro",;
                      "TRAN(produto->prepro, '@E 9,999,999.99')",;         // <----Euro    "produto->prepro"
                      "produto->datpro",;
                      "produto->sitpro",;
                      "produto->obspro" }

RETURN aColumnFields 


